Attribute VB_Name = "mdlFiniteInfinity"
' FiniteInfinity's algo

' Autor comments:
   '  There is still time when it does accept invalid numerals,
   ' but i'm working on that. Tell me what you think.

Private Sub ErrorHandler(intErrorCode As Integer)
Dim strMessage As String

Select Case intErrorCode
Case Is = "1"
strMessage = "Invalid Roman Numeral Sequence: Subtraction numeral cannot be less than 10 times smaller than parent numeral."
Case Is = "2"
strMessage = "Invalid Roman Numeral Sequence: Cannot subtract more than one numeral from parent numeral."
Case Is = "3"
strMessage = "Invalid Roman Numeral Sequence: Cannot have more than 3 identical numerals in a row."
Case Is = "4"
strMessage = "Invalid Roman Numeral Sequence: You cannot subtract a subtraction from another numeral."
Case Is = "5"
strMessage = "Invalid Roman Numeral Sequence: Subtraction must occur at the end of a sequence of identical numerals."
Case Is = "6"
strMessage = "Invalid Roman Numeral Sequence: You may only use the numerals I, X and C in subtractions."
Case Is = "7"
strMessage = "Invalid Roman Numeral Sequence: A sequence of Roman numerals must only contain the following characters I, V, X, L, C, D and M."
Case Is = "8"
strMessage = "Invalid Roman Numeral Sequence: Numerals after a subtraction must be less than the subtracted numeral."
Case Else
strMessage = "Unknown Error."
End Select

MsgBox strMessage, vbExclamation + vbOKOnly, "Roman Numeral Converter"
End Sub
'
' mlngGetNumeralValue()
'
' Converts a string numeral into a numeric value. Returns '-1' if the supplied character is not a numeral.
'
' 20 Apr 2003
'
Private Function mlngGetNumeralValue(strNumeral As String) As Long
Dim lngRetVal As Long
Dim strDigit As String

' Make the supplied character uppercase.
strDigit = Format(strNumeral, ">")

' Return the value of the character if it could be identified as a numeral.
Select Case strDigit
Case Is = "I"
lngRetVal = 1
Case Is = "V"
lngRetVal = 5
Case Is = "X"
lngRetVal = 10
Case Is = "L"
lngRetVal = 50
Case Is = "C"
lngRetVal = 100
Case Is = "D"
lngRetVal = 500
Case Is = "M"
lngRetVal = 1000
End Select

' Return an error code if the character could not.
If lngRetVal = 0 Then
lngRetVal = -1
End If

mlngGetNumeralValue = lngRetVal
End Function

Public Function glngNumeralToDecimal(strNumerals As String) As Long
Dim lngPrevious As Long
Dim lngCurrent As Long
Dim lngRetVal As Long
Dim intCount As Integer
Dim intLen As Integer
Dim intRepeat As Integer
Dim intErrorCode As Integer
Dim blnSubtract As Boolean

intLen = Len(strNumerals)

For intCount = 1 To intLen
lngCurrent = mlngGetNumeralValue(Mid(strNumerals, intCount, 1))

' If this is not a valid numeral...
If lngCurrent = -1 Then
intErrorCode = 7
Exit For

' If this is a subtraction...
ElseIf lngCurrent > lngPrevious And intCount <> 1 Then
If blnSubtract = True Then
intErrorCode = 4
Exit For
ElseIf intRepeat <> 0 Then
intErrorCode = 2
Exit For
ElseIf lngPrevious * 10 < lngCurrent Then
intErrorCode = 1
Exit For
ElseIf lngPrevious Mod 9 = 5 Then
intErrorCode = 6
Exit For
End If
blnSubtract = True
lngRetVal = lngRetVal - (2 * lngPrevious)

' If this is a repeated numeral...
ElseIf lngCurrent = lngPrevious Then
If blnSubtract = True Then
intErrorCode = 5
Exit For
End If
intRepeat = intRepeat + 1
If intRepeat > 2 Then
intErrorCode = 3
Exit For
End If

' Otherwise...
Else
If blnSubtract = True Then
' Ensures the numeral immediately after a subtraction is less than the numeral than was subtracted.
If lngCurrent * 10 >= lngPrevious And lngCurrent Mod 9 = 1 Then
intErrorCode = 8
Exit For
End If
'
If lngCurrent * 10 > lngPrevious And lngCurrent Mod 9 = 5 Then
intErrorCode = 8
Exit For
End If
End If

intRepeat = 0
blnSubtract = False
End If

' Add the value of the current numeral to the total
lngRetVal = lngRetVal + lngCurrent
lngPrevious = lngCurrent
Next intCount

If intErrorCode <> 0 Then
lngRetVal = 0
ErrorHandler (intErrorCode)
End If

glngNumeralToDecimal = lngRetVal
End Function
